︠2ec1ab59-aa8e-42e2-adc6-1f4c1430d786︠

︠c4eb26e6-7a6c-440d-bb87-b61e7886f371︠
%md
####The Inhomogeneous Transport Equation:  $u_t(x,t) + v\ u_x (x,t)= f(x,t), u(x,0)=g(x)$

If $v$ is constant, the solution is $u(x,t)=g(x-v\ t)+\displaystyle\int_0^t f(x-v(t-s),s)\ ds$.  We can plot it for any nice $g$ and $f$.


Use the interact below to experiment with changing the right hand side f and  the initial condition g to see the effect on u.
The graphs shown are of $u_{t_i}(x)=u(x,t_i)$ for $t_i=t_0+i\ step$ for $i=0, \cdots ,5$.  They are color-coded black, red, blue, grey, magenta, turquoise in order of increasing time.


︡68ac15fe-8f12-49d7-b3f5-3db2a875860f︡{"md":"####The Inhomogeneous Transport Equation:  $u_t(x,t) + v\\ u_x (x,t)= f(x,t), u(x,0)=g(x)$\n\nIf $v$ is constant, the solution is $u(x,t)=g(x-v\\ t)+\\displaystyle\\int_0^t f(x-v(t-s),s)\\ ds$.  We can plot it for any nice $g$ and $f$.\n\n\nUse the interact below to experiment with changing the right hand side f and  the initial condition g to see the effect on u.\nThe graphs shown are of $u_{t_i}(x)=u(x,t_i)$ for $t_i=t_0+i\\ step$ for $i=0, \\cdots ,5$.  They are color-coded black, red, blue, grey, magenta, turquoise in order of increasing time.\n\n\n"}︡
︠f435ce8d-e32c-44eb-8bac-7f384c401df8︠
x,t=var('x t')
@interact(layout={'top':[['f','g','v','frames'],['xmin','xmax','t0','step']]})
def getem(f=sin(x+5*t),g=1/exp(x^2),v=1,frames=1,xmin=-1.,xmax=1.,t0=.1,step=.2):
    def f1(x,t):
        return f(x=x,t=t)
    def g1(x):
        return g(x=x)
    clrs=['black','red','blue','grey','magenta','turquoise']
    def u(x,t):
        def h(s):
            return f1(x-v*(t-s),s).n()
        return numerical_integral(h,(0,t))[0]+g1(x-v*t)
    G=Graphics()
    for i in range(frames):
        def w(x):
            return u(x,t0)
        G+=plot(w,(xmin,xmax),color=clrs[i])
        if frames==1:
            tab=[[('x','t0')],['u(x,t0)']]
            pts=[]
            x0=xmin
            dx=(xmax-xmin)/4
            for j in range(5):
                tab[0]+=[(x0.n(digits=6),t0.n(digits=6))]
                tab[1]+=[u(x0,t0).n(digits=6)]
                pts+=[(x0,w(x0))]
                x0+=dx
            G+=point(pts)
        t0+=step
    show(G)
    if frames==1:
        print table(tab)

︡f0b37e11-a55b-43ba-b273-b08d15dbac1d︡{"interact":{"style":"None","flicker":false,"layout":[[["f",3,null],["g",3,null],["v",3,null],["frames",3,null]],[["xmin",3,null],["xmax",3,null],["t0",3,null],["step",3,null]],[["",12,null]]],"id":"c185069f-3ee2-4102-b3dc-897b9eb5ed6f","controls":[{"control_type":"input-box","default":"sin(5*t + x)","label":"f","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"f","type":null},{"control_type":"input-box","default":"e^(-x^2)","label":"g","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"g","type":null},{"control_type":"input-box","default":1,"label":"v","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"v","type":null},{"control_type":"input-box","default":1,"label":"frames","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"frames","type":null},{"control_type":"input-box","default":"-1.00000000000000","label":"xmin","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"xmin","type":null},{"control_type":"input-box","default":"1.00000000000000","label":"xmax","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"xmax","type":null},{"control_type":"input-box","default":"0.100000000000000","label":"t0","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"t0","type":null},{"control_type":"input-box","default":"0.200000000000000","label":"step","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"step","type":null}]}}︡
︠b3a3935d-c3ab-4be3-8d59-16e5acb5f7f1︠

︡30e0ff55-6579-4930-a364-dc92bfc467c6︡
︠d79da212-a56c-48e3-9c9b-22678a4f9766︠

︡2cddb70f-e441-432e-a9e3-27b5eec47aa5︡
︠25109b31-5bf3-4020-ad44-f45d88fb55cd︠









